////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// Arduino UNO
//
////////////////////////
// ИНОПЛАНЕТНЫЙ ГЕКСАПОД 2 СЕРВОПРИВОДА ПУЛЬТ
//
#include <Servo.h>
 byte a =85; //начальный угол диска
 byte da=15;//амплитуда шага диска
 byte b=88;// начальный угол арки
 byte db=15;//амплитуда подъёма-опускания арки
 byte n=5;//временной интервал
 byte i=0;//счётчик
 byte j=0;//счётчик
 byte sh=0;//счётчик числа шагов заданного в массиве типа
const byte K=24;
 
 String inputString;// строки данных
 long Y=0;//переменная хранения моментов времени
 byte SOST_=4;// ФЛАГ СОСТОЯНИЯ ДВИЖЕНИЯ
 byte tabl[K]={};//массив для записи команд движения
 byte fl_=0;//флаг состояний движения по командам с пульта (0)или по записи (1)или по памяти (2)
 
////////////////////////////
Servo servo_a;//диск (4 ноги)
Servo servo_b;//арка (2 ноги)
void setup()
{
 for(i=0;i<K;i=i+2){ 
 tabl[i]=4;tabl[i+1]=10; 
 }
 
  servo_a.attach(6);//вывод управления сервоприводом качания диска
  servo_a.write(a);// установка начального угла
  servo_b.attach(7);//вывод управления сервоприводом качания арки
  servo_b.write(b);// установка начального угла
 Serial.begin(9600);
}

void loop()
{
 ////////
 if(fl_==2){SOST_= tabl[j];ispol();sh++;if(sh>tabl[j+1]){sh=0;j=j+2;if(j>K-1){j=0;}}}
 ////////
 else{if(fl_==0) 
{ispol();}
 }
if(fl_==1){delay_(n);} 
}
/////////////////////////// вперёд /////////////////////////////////////////// 
 void priamo(byte k){
  for(i=0;i<k;i++){ 
 while(servo_b.read()>(b-db)){servo_b.write(servo_b.read()-1);delay_(n);}
 while(servo_a.read()<(a+da)){servo_a.write(servo_a.read()+1);delay_(n);}
 while(servo_b.read()<(b+db)){servo_b.write(servo_b.read()+1);delay_(n);}
 while(servo_a.read()>(a-da)){servo_a.write(servo_a.read()-1);delay_(n);} 
 }}
/////////////////////////// назад ////////////////////////////////////////////
 void nazad(byte k){
  for(i=0;i<k;i++){ 
 while(servo_b.read()>(b-db)){servo_b.write(servo_b.read()-1);delay_(n);}
 while(servo_a.read()>(a-da)){servo_a.write(servo_a.read()-1);delay_(n);}
 while(servo_b.read()<(b+db)){servo_b.write(servo_b.read()+1);delay_(n);}
 while(servo_a.read()<(a+da)){servo_a.write(servo_a.read()+1);delay_(n);} 
 }}
 /////////////////////////// влево-вперёд ////////////////////////////////////////////
 void vlevo_1(byte k){
  for(i=0;i<k;i++){ 
 while(servo_b.read()>(b)){servo_b.write(servo_b.read()-1);delay_(n);}
 while(servo_a.read()<(a+da)){servo_a.write(servo_a.read()+1);delay_(n);}
 while(servo_b.read()<(b+db)){servo_b.write(servo_b.read()+1);delay_(n);}
 while(servo_a.read()>(a-da)){servo_a.write(servo_a.read()-1);delay_(n);}

 }}
 /////////////////////////// влево-назад ////////////////////////////////////////////
 void vlevo_2(byte k){
  for(i=0;i<k;i++){ 
 while(servo_b.read()>(b)){servo_b.write(servo_b.read()-1);delay_(n);}
 while(servo_a.read()>(a-da)){servo_a.write(servo_a.read()-1);delay_(n);}
 while(servo_b.read()<(b+db)){servo_b.write(servo_b.read()+1);delay_(n);}
 while(servo_a.read()<(a+da)){servo_a.write(servo_a.read()+1);delay_(n);}

 }}
/////////////////////////// вправо-вперёд ////////////////////////////////////////////
 void vpravo_1(byte k){
  for(i=0;i<k;i++){ 
 while(servo_b.read()>(b-db)){servo_b.write(servo_b.read()-1);delay_(n);}
 while(servo_a.read()<(a+da)){servo_a.write(servo_a.read()+1);delay_(n);}
 while(servo_b.read()<(b)){servo_b.write(servo_b.read()+1);delay_(n);}
 while(servo_a.read()>(a-da)){servo_a.write(servo_a.read()-1);delay_(n);} 
 }}
 /////////////////////////// вправо-назад ////////////////////////////////////////////
 void vpravo_2(byte k){
  for(i=0;i<k;i++){ 
 while(servo_b.read()>(b-db)){servo_b.write(servo_b.read()-1);delay_(n);}
 while(servo_a.read()>(a-da)){servo_a.write(servo_a.read()-1);delay_(n);}
 while(servo_b.read()<(b)){servo_b.write(servo_b.read()+1);delay_(n);}
 while(servo_a.read()<(a+da)){servo_a.write(servo_a.read()+1);delay_(n);}

 }}
 /////////////////////////// на месте 1 ////////////////////////////////////////////
 void na_meste_1(byte k){
  for(i=0;i<k;i++){ 
 while(servo_b.read()>(b-db)){servo_b.write(servo_b.read()-1);delay_(n);}
 while(servo_a.read()<(a+da)){servo_a.write(servo_a.read()+1);delay_(n);}
 while(servo_a.read()>(a-da)){servo_a.write(servo_a.read()-1);delay_(n);} 
 while(servo_b.read()<(b+db)){servo_b.write(servo_b.read()+1);delay_(n);}
 while(servo_a.read()<(a+da)){servo_a.write(servo_a.read()+1);delay_(n);}
 while(servo_a.read()>(a-da)){servo_a.write(servo_a.read()-1);delay_(n);} 
 }}
 /////////////////////////// на месте 2 ////////////////////////////////////////////
 void na_meste_2(byte k){
  for(i=0;i<k;i++){
 while(servo_b.read()<(b+db)){servo_b.write(servo_b.read()+1);delay_(n);}    
 while(servo_b.read()>(b-db)){servo_b.write(servo_b.read()-1);delay_(n);}
 }}
  /////////////////////////// на месте 3 ////////////////////////////////////////////
 void na_meste_3(byte k){
  for(i=0;i<k;i++){
 while(servo_b.read()<(b)){servo_b.write(servo_b.read()+1);delay_(n);}    
 while(servo_b.read()>(b)){servo_b.write(servo_b.read()-1);delay_(n);}
 while(servo_a.read()<(a+da)){servo_a.write(servo_a.read()+1);delay_(n);}
 while(servo_a.read()>(a-da)){servo_a.write(servo_a.read()-1);delay_(n);} 
 }}
 /////////////////////////// вправо ////////////////////////////////////////////
 void vpravo_3(byte k){
  for(i=0;i<k;i++){ 
 /////
 
 while(servo_a.read()>(a-da)){servo_a.write(servo_a.read()-1);delay_(n);}
 /////   
 while(servo_b.read()>(b-db)){servo_b.write(servo_b.read()-1);delay_(n);}
 while(servo_a.read()<(a+da)){servo_a.write(servo_a.read()+1);delay_(n);}
 while(servo_b.read()<(b)){servo_b.write(servo_b.read()+1);delay_(n);}
 while(servo_a.read()>(a-da)){servo_a.write(servo_a.read()-1);delay_(n);}
 ////
 while(servo_b.read()<(b+db)){servo_b.write(servo_b.read()+1);delay_(n);}
 while(servo_a.read()<(a+da)){servo_a.write(servo_a.read()+1);delay_(n);} 
 ////
 while(servo_b.read()>(b)){servo_b.write(servo_b.read()-1);delay_(n);}
 while(servo_a.read()>(a-da)){servo_a.write(servo_a.read()-1);delay_(n);}
 while(servo_b.read()<(b+db)){servo_b.write(servo_b.read()+1);delay_(n);}
 while(servo_a.read()<(a+da)){servo_a.write(servo_a.read()+1);delay_(n);} 
 }}
 /////////////////////////// влево ////////////////////////////////////////////
 void vlevo_3(byte k){
  for(i=0;i<k;i++){ 
 ////
 while(servo_b.read()<(b+db)){servo_b.write(servo_b.read()+1);delay_(n);}
 while(servo_a.read()>(a-da)){servo_a.write(servo_a.read()-1);delay_(n);}
 ////   
 while(servo_b.read()>(b)){servo_b.write(servo_b.read()-1);delay_(n);}
 while(servo_a.read()<(a+da)){servo_a.write(servo_a.read()+1);delay_(n);}
 while(servo_b.read()<(b+db)){servo_b.write(servo_b.read()+1);delay_(n);}
 while(servo_a.read()>(a-da)){servo_a.write(servo_a.read()-1);delay_(n);}
 ////
 
 while(servo_a.read()<(a+da)){servo_a.write(servo_a.read()+1);delay_(n);}
 ////
 while(servo_b.read()>(b-db)){servo_b.write(servo_b.read()-1);delay_(n);}
 while(servo_a.read()>(a-da)){servo_a.write(servo_a.read()-1);delay_(n);}
 while(servo_b.read()<(b)){servo_b.write(servo_b.read()+1);delay_(n);}
 while(servo_a.read()<(a+da)){servo_a.write(servo_a.read()+1);delay_(n);}

 }}
 //////////////////////////////////////////////////////////////////////////////////
 ////  ФУНКЦИИ ОПИСАНИЕ // вместо задержки времени через delay  ////////////////////////////////////////
void delay_(int T1)
{
 Y=millis();
 while(millis()-Y<T1) 
  {
     CheckSerial();//ЖДЁМ ПОСТУПЛЕНИЯ КОМАНДЫ 
   }
}
 ////////////////////////////////////////////////////////////////////
 /////////////////////////////////////////////////////////////////////////////////////////////////
//ФУНКЦИИ ПРИЁМА И ОБРАБОТКИ ДАННЫХ
void CheckSerial()
{
  //////////////////////////////////////////////////////////////////////////////
  while (Serial.available())//считываем строку данных пока они поступают
  {
    char inChar = (char)Serial.read();
    if (inChar == '\n')     //если окончание строки
    {
      MakeCmd();//обрабатываем её данной функцией
      break;
    }
    else inputString += inChar;// иначе удлиняем строку на один символ
  }
}
/////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////
void MakeCmd()
{
  int y = inputString.length(); // присваиваем переменной у число символов в строке
  if (y < 1 || y > 1)return; //если их меньше 1 или больше, выходим из функции
  String cmd = inputString; // передаём строку другой переменной
  inputString = "";//"обнуляем переменную"
////////////////////////////////////////////////
if (cmd == "D") {
fl_++;SOST_=4;
 if (fl_==2){for(i=j+2;i<K;i=i+2){ 
 tabl[i]=4;tabl[i+1]=10; 
 }}
j=0;if( fl_==3){fl_=0;}
//Serial.println(fl_);
  }
  ////////////////////////////////////
if( fl_==0){
  if (cmd == "1") {
  
  SOST_=0;
  }
  if (cmd == "2") {
   
   SOST_=1;
  
    
  }
  if (cmd == "5") {

   SOST_=5;
  }
  if (cmd == "8") {
   SOST_=8;
  }
  if (cmd == "A") {
 
 SOST_=4;
  }
 
  if (cmd == "9") {
  
   SOST_=9;
  }
  if (cmd == "7") {
  
   SOST_=7; 
  }
  if (cmd == "6") {
  
   SOST_=6; 
  }
  if (cmd == "3") {
   
   SOST_=2; 
  }
  if (cmd == "4") {
   
   SOST_=3; 
  }
  
}
  /////////////////////////////////////
  if( fl_==1){
   SOST_=4; 
  if (cmd == "1") {
  if(tabl[j]!=0){j=j+2;if(j>K-1){j=0;}tabl[j+1]=0;}
  tabl[j]=0;tabl[j+1]++;if(tabl[j+1]>250){tabl[j+1]=0;}
  }
  if (cmd == "2") {
  if(tabl[j]!=1){j=j+2;if(j>K-1){j=0;}tabl[j+1]=0;}
  tabl[j]=1;tabl[j+1]++;if(tabl[j+1]>250){tabl[j+1]=0;} 
  }
  if (cmd == "5") {
  if(tabl[j]!=5){j=j+2;if(j>K-1){j=0;}tabl[j+1]=0;}
  tabl[j]=5;tabl[j+1]++;if(tabl[j+1]>250){tabl[j+1]=0;}
 
  }
  if (cmd == "8") {
    if(tabl[j]!=8){j=j+2;if(j>K-1){j=0;}tabl[j+1]=0;}
  tabl[j]=8;tabl[j+1]++;if(tabl[j+1]>250){tabl[j+1]=0;}
  
  }
 // if (cmd == "A") {
 //if(tabl[j]!=4){j=j+2;if(j>K-1){j=0;}tabl[j+1]=0;}
 // tabl[j]=4;tabl[j+1]++;if(tabl[j+1]>250){tabl[j+1]=0;}
 
 // }
 
  if (cmd == "9") {
  if(tabl[j]!=9){j=j+2;if(j>K-1){j=0;}tabl[j+1]=0;}
  tabl[j]=9;tabl[j+1]++;if(tabl[j+1]>250){tabl[j+1]=0;}
 
  }
  if (cmd == "7") {
  if(tabl[j]!=7){j=j+2;if(j>K-1){j=0;}tabl[j+1]=0;}
  tabl[j]=7;tabl[j+1]++;if(tabl[j+1]>250){tabl[j+1]=0;}
 
  }
  if (cmd == "6") {
  if(tabl[j]!=6){j=j+2;if(j>K-1){j=0;}tabl[j+1]=0;}
  tabl[j]=6;tabl[j+1]++;if(tabl[j+1]>250){tabl[j+1]=0;}
 
  }
  if (cmd == "3") {
   if(tabl[j]!=2){j=j+2;if(j>K-1){j=0;}tabl[j+1]=0;}
  tabl[j]=1;tabl[j+1]++;if(tabl[j+1]>250){tabl[j+1]=0;}
  
  }
  if (cmd == "4") {
  if(tabl[j]!=3){j=j+2;if(j>K-1){j=0;}tabl[j+1]=0;}
  tabl[j]=3;tabl[j+1]++;if(tabl[j+1]>250){tabl[j+1]=0;} 
  
  }
  
}

  /////////////////////////////////////
  
  if (cmd == "B") {
   n=n+5;if(n>15){n=5;}
  } 
}

///////////////////////////////////////////////////////////////////////////////////////////////////////
///// функция исполнения шагов заданного типа
///////////////////////////////////////////////////////////////////////////////////////////////////////
void ispol(){
 if(SOST_==4){delay_(5*n);}//состояние покоя
 if(SOST_==0){priamo(1);}//вперёд 
 if(SOST_==1){nazad(1);}//назад
 if(SOST_==5){vpravo_1(1);}//вправо-вперёд
 if(SOST_==8){vlevo_1(1);}//влево-вперёд
 if(SOST_==9){na_meste_1(1);}//топтание на месте  
 if(SOST_==7){vlevo_2(1);}//влево-назад
 if(SOST_==6){vpravo_2(1);}//вправо-назад
 if(SOST_==2){vpravo_3(1);}//вправо
 if(SOST_==3){vlevo_3(1);}//влево 
}
////////
